;-----------------------------------------------------------------------------;
; DISKX - The disk/partiiton transfer tool
;-----------------------------------------------------------------------------;
; R0.04  Final Version. Changed license to GNU GPL.
; OPTASM 1.6 or later is required to build this program.
;-----------------------------------------------------------------------------;
;
; DISKX R0.04  Copyright (C)2008  ChaN
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;-----------------------------------------------------------------------------;

include	stddef.inc
include	str.inc
include	file.inc
include ibmpc.inc


PartitionTbl	struc
 BootID		db	?	; 80h:Active, 00:Inactive
 StartHead	db	?	; Jnwbhԍ
 StartSectCyl	dw	?	; JnZN^ԍƃV_ԍ
 SystemID	db	?	; OSʃR[h
 EndHead	db	?	; ŏIwbhԍ
 EndSectCyl	dw	?	; ŏIZN^ԍ
 PartitionOfs	dw	?,?	; JnZN^iLBAj
 PartitionSize	dw	?,?	; TCYiZN^j
PartitionTbl	ends

OfsFat12	equ	36h
OfsFat16	equ	36h
OfsHpfs		equ	36h
OfsFat32	equ	52h
OfsNtfs		equ	3h
OfsHidden	equ	1ch



FPRIN		macro	form,par1,par2,par3,par4,par5,par6,par7,par8
		mov	bp,sp
		push	ofs form
	IRP par,<par1,par2,par3,par4,par5,par6,par7,par8>
	  IFNB <par>
		push	par
	  ENDIF
	ENDM
		 call	PRINTF
		endm


PRINT		macro	str
	IFNB <str>
		mov	si, ofs str
	ENDIF
		 call	put_str
		endm



.model t
.data


StrOpen		db	'DISKX - The drive/partition transfer tool. R0.04 (C)ChaN, 2008.',CR,LF,CR,LF,0

StrUsage	db	'Usage: diskx status',CR,LF
		db	'       diskx [!]copy <src drive> <src partition> <dst drive> <dst partition>',CR,LF
		db	'       diskx [!]copy_all <src drive> <dst drive>',CR,LF
		db	'       diskx [!]erase_all <drive>',CR,LF,CR,LF
		db	'<command>:   status = Show partition status on each drive.',CR,LF
		db	'             copy = Copy partition.',CR,LF
		db	'             copy_all = Copy drive.',CR,LF
		db	'             erase_all = Erase drive.',CR,LF
		db	'             *Leading ! shuts down PC when the command terminate successful.',CR,LF
		db	'<drive>:     Drive number shown in status',CR,LF
		db	'<partition>: Partition number shown in status'
CrLf		db	CR,LF,0

CmdStrS		db	'status',0
CmdStrC		db	'copy',0
CmdStrA		db	'copy_all',0
CmdStrE		db	'erase_all',0

MessNoLba	db	'Disk error or No LBA supportment.',CR,LF,0
ErrRead		db	'Read error.',CR,LF,0
ErrWrite	db	'Write error.',CR,LF,0

Progress	db	CR,0,'%, ',0,' sectors processed...',0
EndProcess	db	CR,'Function completed.                   ',CR,LF,BEL,0
ShutDown	db	CR,LF,'Shut Down...',0

EnqEra1		db	'You are just going to erase all data on the drive %ui (0x%h2).%n'
		db	'Are you sure? <y/n>=',0

EnqDup1		db	'The data on drive %ui will be copied to drive %ui.%n'
		db	'All data on the drive %ui will be lost!%n'
		db	'Do you wish to continue? <y/n>=',0
ErrTargetSmall	db	'Error: The destination drive is smaller than source drive.',CR,LF,0

EnqCopy1	db	'The partition will be copied as follows:',CR,LF,CR,LF,'From:',0
EnqCopy2	db	'To:  ',0
EnqCopy3	db	'All data on the destination partition will be lost!',CR,LF
		db	'Do you wish to continue? <y/n>=',0
EnqCopy4	db	'The source partition has %s file system.%n'
		db	'Do you wish to convert parameters in BPB? <y/n>=',0

ErrTargetDiffer	db	'Error: The destination size and the source size are not the same.',CR,LF,0
ErrNoPartition	db	'Error: No such partition.',CR,LF,0



DiskInfo1	db	'D#  P#  System ID                 Offset     Length     Size',CR,LF,0
DiskInfo2	db	'--  --  ----------------------- ---------- ---------- -------',CR,LF,0
DiskInfo3	db	'Total space on drive %ui:                   ',0
DiskInfo4	db	'MB',0,'GB',0,'  0x',0


SignFat12	db	'FAT12'
		db	0
SignFat16	db	'FAT16'
		db	0
SignFat32	db	'FAT32'
		db	0
SignHpfs	db	'HPFS'
		db	0
SignNtfs	db	'NTFS'
		db	0

Shut		db	0

OsTable		db	01h,'DOS FAT12         ',0
		db	04h,'DOS FAT16(<32M)   ',0
		db	05h,'DOS Extend        ',0
		db	06h,'DOS FAT16(32M-2G) ',0
		db	07h,'HPFS/NTFS         ',0
		db	0bh,'DOS FAT32         ',0
		db	0ch,'DOS FAT32X        ',0
		db	0eh,'DOS FAT16X        ',0
		db	0fh,'DOS ExtendX       ',0
		db	11h,'DOS FAT12         ',0
		db	13h,'B-right/V         ',0
		db	14h,'DOS FAT16(<32M)   ',0
		db	15h,'DOS Extend(masked)',0
		db	16h,'DOS FAT16(32M-2G) ',0
		db	17h,'HPFS/NTFS         ',0
		db	1bh,'DOS FAT32         ',0
		db	1ch,'DOS FAT32X        ',0
		db	1eh,'DOS FAT16X        ',0
		db	1fh,'DOS ExtendX       ',0
		db	39h,'Plan 9            ',0
		db	71h,'EOTA              ',0
		db	81h,'Minix/Linux extfs ',0
		db	82h,'Solaris/Linux swap',0
		db	83h,'Linux ext2fs      ',0
		db	85h,'Linux Extend      ',0
		db	0a0h,'Suspend           ',0
		db	0a4h,'FreeBSD           ',0
		db	0a5h,'FreeBSD           ',0
		db	0a6h,'OpenBSD           ',0
		db	0a9h,'NetBSD            ',0
		db	0c1h,'DRDOS             ',0
		db	0c4h,'DRDOS             ',0
		db	0c6h,'DRDOS(32M-2G)     ',0
		db	0ebh,'BeOS              ',0
		db	0,   'Unknown           ',0

		even

SegBuff		dw	?

SrcDrive	db	0,0
DstDrive	db	0,0
XferTotal	dw	0,0
XferCount	dw	0,0
SrcSect		dw	0,0
DstSect		dw	0,0

SrcPartition	label byte
		PartitionTbl	<>
DstPartition	label byte
		PartitionTbl	<>

		even

MbrBuffer	db	512 dup(?)	; u[gR[hǂݏobt@
		org	$-64-2		; e[uiMBR̂݁j
 MbrPartition	PartitionTbl	<>
		PartitionTbl	<>
		PartitionTbl	<>
		PartitionTbl	<>
 MbrSign	dw	?		; VOl`iAA55hj


Drive1		db	?,?
Length1		dw	?,?
PartitionList1	label	byte
  REPT 16
		PartitionTbl	<>
  ENDM




Argc		db	?
Argv		dw	5 dup(?)

Pool		db	?



;-------------------------------------------------;
; Main

.186
.code

		DEF_PSP
start:
		PRINT	StrOpen

		mov	sp, 4000h
		mov	ax, cs
		add	ax, 400h
		mov	SegBuff, ax

		GET_CMD_PAR  Argc, Argv
		mov	bx, Argv[0]
	_if e, bptr[bx], '!'
		mov	Shut, ON
		inc	bx
	_endif
		CMP_STR bx,<ofs CmdStrS>,<len CmdStrS>
		je	status
		CMP_STR bx,<ofs CmdStrC>,<len CmdStrC>
		je	copy
		CMP_STR bx,<ofs CmdStrA>,<len CmdStrA>
		je	copy_all
		CMP_STR bx,<ofs CmdStrE>,<len CmdStrE>
		je	erase_all


usage:		PRINT	StrUsage
		jmp	quit
err_r:		PRINT	ErrRead
		jmp	quit
err_w:		PRINT	ErrWrite
		jmp	quit
err_lba:	PRINT	MessNoLba
		jmp	quit
err_partition1:	PRINT	ErrNoPartition
		jmp	quit
err_partition2:	PRINT	ErrTargetDiffer
quit:		$DOS  4ch,1

successful:	PRINT	EndProcess
	_if e, Shut, ON
		PRINT	ShutDown
		mov	cx, 30
		mov	dx, 8000h
		$SYSTEM  86h
		clr	bx
		$SYSTEM  53h,1
		clr	bx
		mov	cx,101h
		$SYSTEM  53h,0eh
		mov	bx,1
		mov	cx,1
		$SYSTEM  53h,0fh
		mov	bx,1
		mov	cx,1
		$SYSTEM  53h,8
		mov	bx,1
		mov	cx,3
		$SYSTEM  53h,7
	_endif

exit:		$DOS  4ch,0


;-------------------------------------------------;
; Status

status:
		mov	Drive1, 80h
	_while
		 call	get_lba1
	 _break c
		 call	scan_partitions1
	 _if e, Drive1, 80h
		PRINT	DiskInfo1
	 _endif
		 call	disp_partitions1
		inc	Drive1
	_rept

		jmp	exit




;-------------------------------------------------;
; Copy partition

copy:
		cjne	Argc, 5, usage

		mov	si, Argv[2]	;Get source
		 call	get_value	;
		jc	usage		;
		or	cl, 80h		;
		mov	SrcDrive[0], cl	;
		mov	Drive1, cl	;
		mov	si, Argv[4]	;
		 call	get_value	;
		jc	usage		;
		cje	cx, 0, usage	;
		cja	cx, 16, usage	;
		mov	SrcDrive[1], cl	;/
		push	cx
		 call	get_lba1
		jc	err_lba
		 call	scan_partitions1
		pop	ax
		dec	ax
		imul	si, ax, type PartitionTbl
		add	si, ofs PartitionList1
		cje	[si].SystemID, 0, err_partition1
		@32 <mov ax, [si].PartitionOfs>
		@32 <mov SrcSect, ax>
		@32 <mov ax, [si].PartitionSize>
		@32 <mov XferTotal, ax>
		MOV_MEM <>,<ofs SrcPartition>,<type PartitionTbl>

		mov	si, Argv[6]	;Get destination
		 call	get_value	;
		jc	usage		;
		or	cl, 80h		;
		mov	DstDrive[0], cl	;
		mov	Drive1, cl	;
		mov	si, Argv[8]	;
		 call	get_value	;
		jc	usage		;
		cje	cx, 0, usage	;
		cja	cx, 16, usage	;
		mov	DstDrive[1], cl	;/
		push	cx
		 call	get_lba1
		jc	err_lba
		 call	scan_partitions1
		pop	ax
		dec	ax
		imul	si, ax, type PartitionTbl
		add	si, ofs PartitionList1
		cje	[si].SystemID, 0, err_partition1
		@32 <mov ax, [si].PartitionOfs>
		@32 <mov DstSect, ax>
		@32 <mov ax, [si].PartitionSize>
		@32 <cmp XferTotal, ax>
		pushf
		MOV_MEM <>,<ofs DstPartition>,<type PartitionTbl>

		PRINT	EnqCopy1
		mov	di, ofs SrcDrive
		mov	bp, ofs SrcPartition
		 call	put_partition
		PRINT	EnqCopy2
		mov	di, ofs DstDrive
		mov	bp, ofs DstPartition
		 call	put_partition
		PRINT	CrLf
		popf
		jne	err_partition2
		PRINT	EnqCopy3
		 call	req_enq
		jne	quit

		 call	exec_copy

		jmp	successful




;-------------------------------------------------;
; Copy drive

copy_all:
		cjne	Argc, 3, usage
		mov	si, Argv[4]	;Get destination drive
		 call	get_value	;
		jc	usage		;
		or	cl, 80h		;
		mov	DstDrive, cl	;
		mov	si, Argv[2]	;Get source drive
		 call	get_value	;
		jc	usage		;
		or	cl, 80h		;
		mov	SrcDrive, cl	;/

		cje	cl, DstDrive, usage

		mov	Drive1, cl	;Get source size
		 call	get_lba1	;
		jc	err_lba		;
		@32 <mov ax, Length1>	;
		@32 <mov XferTotal, ax>	;

		mov	al, DstDrive	;Check destination size
		mov	Drive1, al	;
		 call	get_lba1	;
		jc	err_lba		;
		@32 <mov ax, Length1>	;
		@32 <cmp ax, XferTotal>	;
	_if b
		PRINT	ErrTargetSmall
		$DOS  4ch, 1
	_endif

		mov	al, SrcDrive
		mov	cl, DstDrive
		and	ax, 7fh
		and	cx, 7fh
		FPRIN	EnqDup1, ax, cx, cx
		 call	req_enq
		jne	quit

		 call	exec_copy

		jmp	successful




;-------------------------------------------------;
; Erase drive

erase_all:
		cjne	Argc, 2, usage
		mov	si, Argv[2]	;Get destination drive
		 call	get_value	;
		jc	usage		;
		or	cl, 80h		;
		mov	DstDrive, cl	;/

		mov	Drive1, cl	;Get size
		 call	get_lba1	;
		jc	err_lba		;
		@32 <mov ax, Length1>	;
		@32 <mov XferTotal, ax>	;

		mov	al, DstDrive	;Confirm operation
		mov	cl, al		;
		and	ax, 7fh		;
		FPRIN	EnqEra1, ax, cx	;
		 call	req_enq		;/
		jne	quit

	_while
		@32 <mov ax, XferCount>
		@32 <cmp ax, XferTotal>
	 _break ae
		@32 <clr cx>
		mov	cx, 127
		@32 <add ax, cx>
		@32 <sub ax, XferTotal>
	 _if a
		sub	cx, ax
	 _endif
		push	cx, cx
		mov	es, SegBuff		;Fill buffer
		@32 <mov ax, DstSect>		;
		cld				;
	 _repeat				;
		@32 <push ax>			;
		push	cx			;
		clr	di			;
		@32 <stosw>			;
		mov	cx, 512/4-1		;
		@32 <clr ax>			;
		@32 <rep stosw>			;
		mov	ax, es			;
		add	ax, 512/16		;
		mov	es, ax			;
		pop	cx			;
		@32 <pop ax>			;
		@32 <inc ax>			;
	 _loop					;/
		pop	cx

		@32 <push 0>			;Write destination
		@32 <push DstSect>		;
		push	SegBuff, 0, cx, 16	;
		mov	dl, DstDrive		;
		mov	si, sp			;
		$DISK 43h,0			;
		lea	sp, [si].16		;
		jc	err_w			;/

		@32 <clr ax>			;Update sector count and ptr
		pop	ax			;
		@32 <add XferCount, ax>		;
		@32 <add DstSect, ax>		;/

		 call	disp_progress
	_rept

		jmp	successful




;-------------------------------------------------;



exec_copy:
	_while
		@32 <mov ax, XferCount>
		@32 <cmp ax, XferTotal>
	 _break ae
		@32 <clr cx>
		mov	cx, 127
		@32 <add ax, cx>
		@32 <sub ax, XferTotal>
	 _if a
		sub	cx, ax
	 _endif
		push	cx, cx

		@32 <push 0>			;Read source
		@32 <push SrcSect>		;
		push	SegBuff, 0, cx, 16	;
		mov	dl, SrcDrive		;
		mov	si, sp			;
		$DISK 42h			;
		lea	sp, [si].16		;
		jc	err_r			;/

		 call	convert_bpb

		pop	cx			;Write destination
		@32 <push 0>			;
		@32 <push DstSect>		;
		push	SegBuff, 0, cx, 16	;
		mov	dl, DstDrive		;
		mov	si, sp			;
		$DISK 43h,0			;
		lea	sp, [si].16		;
		jc	err_w			;/

		@32 <clr ax>			;Update sector count and ptr
		pop	ax			;
		@32 <add XferCount, ax>		;
		@32 <add SrcSect, ax>		;
		@32 <add DstSect, ax>		;/

		 call	disp_progress
	_rept
		ret



convert_bpb:
		@32 <mov ax, XferCount>
		@32 <and ax, ax>
		retn z
		@32 <mov ax, SrcSect>
		@32 <cmp ax, DstSect>
		ret e

		mov	dx, ofs SignFat12
		CMP_STR <4000h+OfsFat12>, dx, <len SignFat12>
	_skip e
		mov	dx, ofs SignFat16
		CMP_STR <4000h+OfsFat16>, dx, <len SignFat16>
	 _skip e
		mov	dx, ofs SignFat32
		CMP_STR <4000h+OfsFat32>, dx, <len SignFat32>
	  _skip e
		mov	dx, ofs SignHpfs
		CMP_STR <4000h+OfsHpfs>, dx, <len SignHpfs>
	   _skip e
		mov	dx, ofs SignNtfs
		CMP_STR <4000h+OfsNtfs>, dx, <len SignNtfs>
		retn e
	____endif

		FPRIN EnqCopy4, dx
		 call	req_enq
	_if ne
		PRINT CrLf
		PRINT CrLf
		ret
	_endif
		@32 <mov ax, DstSect>
		@32 <mov ds:[4000h+OfsHidden], ax>
		ret



disp_progress:
		inc	Pool
	_if z,<test	Pool, 15>
		PRINT Progress
		@32 <mov ax, XferTotal>
		mov	cx, 100
		 call	div_eax
		@32 <mov cx, ax>
		@32 <clr dx>
		@32 <mov ax, XferCount>
		@32 <div cx>
		 call	put_num2a
		PRINT
		@32 <mov ax, XferCount>
		 call	put_num4a
		PRINT
	_endif
		ret



req_enq:
		mov	ax, 2
		mov	wptr Pool[0], ax
		mov	dx, ofs Pool
		$DOS  10
		mov	al, Pool[2]
		CAPS	al
	_skip ne, al, 'Y'
		PRINT	CrLf
		PRINT	CrLf
		clr	ax
	_endif
		ret



scan_partitions1:
		FIL_STR <ofs PartitionList1>,256,0
		mov	dl, Drive1
		mov	dh, 0
		mov	cx, 1
		mov	bx, ofs MbrBuffer
		$DISK  2,1
		jc	err_r
	_skip ne, MbrSign, 0aa55h
		mov	si, ofs MbrPartition
		mov	di, ofs PartitionList1
		clr	bp
	 _repeat 4
		push	cx
		mov	dl, [si].SystemID
	  _if e, dl, 0
		add	si, type PartitionTbl
		add	di, type PartitionTbl
	  _else
	   _skip ne, bp, 0
		 call	chk_extend
	    @if e,<mov	bp, si>
	   _endif
		MOV_MEM <>,<>,<type PartitionTbl>
	  _endif
		pop	cx
	 _loop
		 call	search_extend
	_endif
		ret



search_extend:	; ǧ
		cje	bp, 0, exd_x
		@32 <mov ax, [bp].PartitionOfs>
		@32 <mov wptr Pool[0], ax>
		@32 <mov wptr Pool[4], ax>
		mov	Pool[8], 0
exd_lp:		pusha				;Read logical partition table
		mov	dl, Drive1		;
		mov	bx, ofs MbrBuffer	;
		@32 <clr ax>			;
		@32 <push ax>			;
		@32 <push [bp].PartitionOfs>	;
		push	es,bx, 1, 16		;
		mov	si, sp			;
		$DISK  42h			;
		lea	sp, [si].16		;
		popa				;
		jc	exd_x			;
		cjne  MbrSign, 0aa55h, exd_x	;/
		mov	si, ofs MbrPartition
	_repeat 4
		mov	dl, [si].SystemID
		 call	chk_extend
	 _if e
		@32 <mov ax, wptr Pool[0]>
		@32 <add ax, [si].PartitionOfs>
		@32 <mov [si].PartitionOfs, ax>
		@32 <mov wptr Pool[4], ax>
		mov	bp, si
		jmp	exd_lp
	 _endif
	 _skip e, dl, 0
		cjae	di, <ofs PartitionList1[256]>, exd_x
		pusha
		@32 <mov ax, wptr Pool[4]>
		@32 <add [si].PartitionOfs, ax>
		mov	cx, type PartitionTbl
		rep movsb
		popa
	  _endif
		add	di, type PartitionTbl
		add	si, type PartitionTbl
	_loop
exd_x:		ret




get_lba1:	; Get LBA information
		FIL_STR <ofs Pool>,100,0
		mov	dl, Drive1
		mov	bx, 55aah
	_skip c,<$DISK  41h>
	 _skip ne, bx, 0aa55h
	  _skip z, <test cl, BIT0>
		mov	si, ofs Pool
		mov	wptr[si], 1ah
	   _skip c, <$DISK  48h>
	    _skip ne, wptr[si].18h, 512
	     _skip ne, wptr[si].14h, 0
		@32 <mov ax,[si].10h>
		@32 <mov Length1,ax>
		clc
		ret
	    __endif
	____endif
		stc
		ret



chk_extend:	; ZR: dl = gID
	 _skip e, dl, 05h
	  _skip e, dl, 0fh
		cmp	dl, 85h
	 __endif
		ret



disp_partitions1:
		PRINT	DiskInfo2
		mov	di, ofs Drive1
		mov	bp, ofs PartitionList1
		mov	bptr[di].1, 1
	_repeat 16
		push	cx
	 _if ne, [bp].SystemID, 0
		 call	put_partition
	 _endif
		pop	cx
		add	bp, type PartitionTbl
		inc	bptr[di].1
	_loop
		mov	al, [di]
		and	ax, 7fh
		FPRIN	DiskInfo3, ax
		@32 <mov ax, [di].2>	;Total length
		mov	dl, 11		;
		 call	put_num4	;/
		 call	space
		@32 <mov ax, [di].2>	;Total size
		 call	put_size	;/
		PRINT	CrLf
		ret



put_partition:
		mov	al, [di]		;Drive#
		and	al, 7fh			;
		mov	dl, 2			;
		 call	put_num1		;/
		mov	al, [di].1		;Partition#
		mov	dl, 4			;
		 call	put_num1		;/
		PRINT	DiskInfo4[6]		;System ID
		mov	al, [bp].SystemID	;
		 call	put_hex1		;
		mov	al, ':'			;
		 call	put_chr			;
		mov	ah, [bp].SystemID	;
		 call	get_osname		;
		PRINT				;/
		@32 <mov ax, [bp].PartitionOfs>	;Offset
		mov	dl, 11			;
		 call	put_num4		;/
		@32 <mov ax, [bp].PartitionSize>;Length
		mov	dl, 11			;
		 call	put_num4		;/
		 call	space
		@32 <mov ax, [bp].PartitionSize>;Size
		 call	put_size		;/
		PRINT	CrLf
		ret


put_size:	mov	cx, 2048		;sectors/2048 = Mbyte
		 call	div_eax
	_if ae, cx, 2048/2
		@32 <inc ax>
	_endif
		@32 <cmp ax, 36809>,1	;cmp eax, 102345
	_case ae
		mov	cx, 1024
		 call	div_eax
	 _if ae, cx, 1024/2
		@32 <inc ax>
	 _endif
		mov	dl, 5
		 call	put_num2
		mov	al, 'G'
	_case ae, <@32 <cmp ax, 10000>,0>
		push	dx
		@32 <mov dx, 10>,0
		@32 <mul dx>
		pop	dx
		mov	cx, 1024
		 call	div_eax
	 _if ae, cx, 1024/2
		@32 <inc ax>
	 _endif
		mov	cx, 10
		 call	div_eax
		mov	dl, 3
		 call	put_num2
		mov	al, '.'
		 call	put_chr
		mov	al, cl
		mov	dl, 1
		 call	put_num1
		mov	al, 'G'
	_default
		mov	dl, 5
		 call	put_num2
		mov	al, 'M'
	_endc
		 call	put_chr
		mov	al, 'B'
		jmp	put_chr



get_osname:				; Call:
		mov	si, ofs OsTable	;  ah = OS code
	_while				; Ret:
		lodsb			;  si -> String
		ret e, ah, al
	 _while
		lodsb
	 _rept ne, al,0
	_rept ne, bptr[si], 0
		inc	si
		ret


div_eax1:
		clr	ch
div_eax:
		@32 <push dx>		; Call: eax = dividend
		@32 <clr dx>		;       cx = divisor	
		@32 <shl cx,16>		; Ret:  eax = result
		@32 <shr cx,16>		;
		@32 <div cx>		;       cx = remander
		mov	cx, dx
		@32 <pop dx>
		ret


space:		mov	al, ' '
put_chr:	pusha
		mov	dl, al
		$DOS 2
		popa
		ret


put_str:
	_while
		lodsb
	 _break e, al, 0
		 call	put_chr
	_rept
		ret


put_hex1:	push	ax
		shr	al, 4
		 call	put_hex
		pop	ax
put_hex:	and	al, 0fh
		cmp	al, 10
	@if ae,<add	al, 7>
		add	al, '0'
		jmp	put_chr


put_num4a:	clr	dl
		jmp	put_num4
put_num2a:	clr	dl
		jmp	put_num2
put_num1a:	clr	dl
put_num1:	clr	ah
put_num2:	@32 <and ax,-1>,0
put_num4:	push	bx,cx
		clr	bh
	_while
		mov	cl, 10
		 call	div_eax1
		inc	bh
		add	cl, '0'
		push	cx
		@32 <and ax, ax>
	_rept nz
	_while b, bh,dl
		inc	bh
		push	' '
	_rept
		shr	bx, 8
	_repeat bx
		pop	ax
		 call	put_chr
	_loop
		pop	cx,bx
		ret


get_value:	; 10il擾 Ret:ECX=value
		@32 <clr cx>
	_while
		lodsb
	 _break e, al, 0
		sub	al, '0'
	 _break b
		cmp	al, 10
		cmc
	 _break b
		@32 <imul cx,10>
		@32 <and ax, 255>,0
		@32 <add cx, ax>
	_rept
		ret


PRINTF:
		pusha
		decw	bp
		mov	si,[bp]
_pfmlp:
		mov	al,[si]
		inc	si
		cmp	al,0
		je	_pfend
		cmp	al,'%'
		je	_pfchk
		 call	put_chr
		jmp	_pfmlp
_pfend:
		popa
		pop	ax
		mov	sp,bp
		jmp	ax
_pfchk:
		mov	ax,[si]
		inc	si
	_case e, al,'n'				; CRLF ?
		mov	al,CR
		 call	put_chr
		mov	al,LF
		 call	put_chr

	_case e, al,'m'				; CR ?
		mov	al,CR
		 call	put_chr

	_case e, al,'s'				; string ?
		decw	bp
		mov	bx,[bp]
	 _while
		mov	al,[bx]
		inc	bx
	  _break e, al,0
		 call	put_chr
	 _rept

	_case e, al,'h'				; hexdecimal ?
		inc	si
		sub	ah,'0'
		cmp	ah,5
		mov	cx,0402h
	 @if ae,<shl	cx,1>
		sub	ch,ah
	 _while
		dec	bp
		 call	_pfhex
		 call	_pfhex
		dec	cl
	 _rept nz

	_case e, al,'i'				; integer ?
		decw	bp
		mov	dx,[bp]
	 _if s,<tst dh>
		mov	al,'-'
		 call	put_chr
		neg	dx
	 _endif
		 call	_pfint

	_case e, ax,'iu'			; unsigned int ?
		inc	si
		decw	bp
		mov	dx,[bp]
		 call	_pfint

	_case e, al,'c'				; character ?
		decw	bp
		mov	ax,[bp]
	 _if ne, ah,0
		xchg	al,ah
		 call	put_chr
		xchg	al,ah
	 _endif
		 call	put_chr

	_default
		 call	put_chr

	_endc
		jmp	_pfmlp

_pfhex:
		mov	al,[bp]
		ror	al,4
		mov	[bp],al
		and	al,1111b
		cmp	al,9
	@if a, <add	al,7>
		add	al,'0'
		tst	ch
	_if z
		 call	put_chr
		ret
	_endif
		dec	ch
		ret

_pfint:
		mov	cx,0
	_while
		mov	ax,1000h
	 _while
		shl	dx,1
		rcl	al,1
	  _if ae, al,10
		sub	al,10
		set	dl,BIT0
	  _endif
	 _rept nz,<dec ah>
		inc	cx
		push	ax
	_rept nz,<tst dx>
	_while
		pop	ax
		add	al,'0'
		 call	put_chr
	_loop
		ret




		$end	start
